unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  odbcconn, sqldb, db, DBGrids, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
   Button1: TButton;
   Datasource1: TDatasource;
   DBGrid1: TDBGrid;
   Edit1: TEdit;
   Label1: TLabel;
   ODBCConnection1: TODBCConnection;
   SQLQuery1: TSQLQuery;
   SQLQuery1Bezeichnung: TStringField;
   SQLQuery1ID: TLongintField;
   SQLQuery1Wert: TFloatField;
   SQLQuery2: TSQLQuery;
   SQLTransaction1: TSQLTransaction;
   procedure Button1Click(Sender: TObject);
   procedure Datasource1DataChange(Sender: TObject; Field: TField);
   procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  SQLQuery1.UsePrimaryKeyAsKey := FALSE; { MUSS bei FormCreate gesetzt werden, }
  SQLQuery2.UsePrimaryKeyAsKey := FALSE; { die Einstellung im ObjektInspector  }
  TRY                                    { verliert er wieder ¿Bug?            }
     ODBCConnection1.Connected := TRUE;
     SQLQuery1.Active := TRUE;
    EXCEPT
     ShowMessage ('ODBC Fehler');
     Application.Terminate;
   End; { Try...Except }
end; { Form Create }

procedure TForm1.Datasource1DataChange(Sender: TObject; Field: TField);
begin
  Edit1.Text := SQLQuery1.FieldByName('Bezeichnung').AsString;
end; { Datasource1DataChange }

procedure TForm1.Button1Click(Sender: TObject);
VAR ID : Integer;
begin
  ID := SQLQuery1.FieldByName('ID').AsInteger; { Schlüsselfeld merken }
  SQLQuery1.Active := FALSE; { Abfrage schliessen }
  SQLQuery2.SQL.Clear; { UPDATE-SQL Statement zusammenbasteln }
  SQLQuery2.SQL.Add ('UPDATE Tabelle1 SET Bezeichnung = ''' + Edit1.Text + ''' WHERE ID = ' + IntToStr (ID));
  SQLQuery2.ExecSQL; { Rein damit in die Datenbank }
  SQLQuery1.Active := TRUE; { Abfrage wieder öffnen zum Gucken was jetzt in der DB steht }
end; { Button1Click }


initialization
  {$I unit1.lrs}

end.

